package geocode;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import log.SystemLogger;
import setting.GeocodeSettings;

public class APIManager {
	// 萔S
	public static final String NOTFOUND = "null";// f[^擾łȂꍇ̃k

	// ݒpϐS
	private String apiAddress = "http://www.geocoding.jp/api/?q=";

	private String encode = "UTF-8";

	private int waitTimeForNextConnection = 5000; // APIڑւ̑҂

	// ϐS
	static Date lastAccess = new Date(0);

	static GeoData tempGeoData = null;// n擾̕ۑp

	/**
	 * RXgN^
	 * 
	 * @param dBConnecter
	 * @param settings
	 */
	public APIManager(GeocodeSettings settings) {
		initialize(settings);
	}

	/**
	 * ݒ̏
	 * 
	 * @param settings
	 */
	private void initialize(GeocodeSettings settings) {
		apiAddress = settings.getApiURL();
		encode = settings.getApiEncode();
		waitTimeForNextConnection = settings.getRequestWaitTime();
	}

	/**
	 * L[nXg擾郁\bh
	 * 
	 * @param searchKey
	 * @return
	 */
	public List<String> getSearchList(String searchKey) {
		SystemLogger.writer.writeDebug("Access API to get Location names");// fobOvg
		try {
			waitToAccessAPI();// ڑ
			// \[Xw肷
			URL url = new URL(apiAddress + URLEncoder.encode(searchKey, encode));
			SystemLogger.writer.writeDebug("Connect to :"
					+ url.toExternalForm());

			// Xg[𐶐
			BufferedReader in = new BufferedReader(new InputStreamReader(url
					.openStream(), encode));
			String line;
			List<String> getLines = new ArrayList<String>();
			while ((line = in.readLine()) != null) {
				getLines.add(line);
			}

			// nȂꍇ
			if (isResponseSingle(getLines)) {
				tempGeoData = getGeocodedDataFromResponse(getLines);// ۑĂ
				return getLocationNameFromResponse(getLines);
			}
			// nꍇ
			else if (isResponseMultiple(getLines)) {
				return getLocationNamesFromResponse(getLines);
			}
			// nȂꍇ
			else {
				return null;
			}
		} catch (IOException e) {
			SystemLogger.writer.writeError(SystemLogger.ERROR_SOCKET, e);
		}
		return null;
	}

	/**
	 * nn擾郁\bh
	 * 
	 * @param location
	 * @return
	 */
	public GeoData getLocation(String location) {
		GeoData geoData = new GeoData(location, null, null);
		// ȑOɎ擾AۑĂꍇ͂擾
		if (tempGeoData != null
				&& tempGeoData.getLocationName().equals(location)) {
			geoData = tempGeoData;
			tempGeoData = null;
			SystemLogger.writer.writeDebug("Got GeoData before access API:"
					+ geoData.getLocationName() + "," + geoData.getLatitude()
					+ "," + geoData.getLongitude());// fobOvg
			return geoData;
		} else {// قȂꍇiXV؂̏ꍇj
			tempGeoData = null;
		}

		// nn擾
		try {
			SystemLogger.writer.writeDebug("Access API to get GeoData");// fobOvg
			waitToAccessAPI();// ڑ
			// \[Xw肷
			URL url = new URL(apiAddress + URLEncoder.encode(location, encode));
			SystemLogger.writer.writeDebug("Connect to :"
					+ url.toExternalForm());
			// Xg[𐶐
			BufferedReader in = new BufferedReader(new InputStreamReader(url
					.openStream(), encode));
			// ŌɐڑԂL
			lastAccess = new Date();

			// X|XXgƂĕێ
			String line;
			List<String> getLines = new ArrayList<String>();
			while ((line = in.readLine()) != null) {
				getLines.add(line);
			}
			// 擾lɋLڂꂽn̐ɂďς
			if (isResponseSingle(getLines)) {// PƂ̏ꍇ
				geoData = getGeocodedDataFromResponse(getLines);// 擾ln쐬
				if (geoData != null) {
				}
			} else {// 擾łȂꍇ
				geoData = new GeoData(location, null, null);
			}

			// Xg[
			in.close();

		} catch (IOException e) {
			SystemLogger.writer.writeError(SystemLogger.ERROR_SOCKET, e);
		}
		SystemLogger.writer.writeDebug("Got GeoData from API:"
				+ geoData.getLocationName() + "," + geoData.getLatitude() + ","
				+ geoData.getLongitude());// fobOvg
		return geoData;
	}

	/**
	 * APIڑO5bԑ҂
	 * 
	 */
	private void waitToAccessAPI() {
		// ÕANZXƂ̍擾
		long timeDifference = new Date().getTime() - lastAccess.getTime();
		// ҂ԂKvǂ肷
		if (timeDifference < waitTimeForNextConnection) {// Kvȏꍇ
			long timeToWait = waitTimeForNextConnection - timeDifference;
			try {
				Thread.sleep(timeToWait);
			} catch (InterruptedException e) {
				SystemLogger.writer.writeError(SystemLogger.ERROR_SOCKET, e);
			}
		}
	}

	/**
	 * ʂPƉ񓚂̂̂ǂ𔻒肷
	 * 
	 * @param lines
	 * @return
	 */
	private boolean isResponseSingle(List<String> lines) {
		for (String string : lines) {
			// ̑Iꍇ
			if (string.startsWith("<choices>")) {
				return false;
			}
			// ܓxoxԂĂꍇ
			else if (string.startsWith("<lat>")) {
				return true;
			}
		}
		return false;
	}

	/**
	 * ʂ񓚂̂̂ǂ𔻒肷
	 * 
	 * @param lines
	 * @return
	 */
	private boolean isResponseMultiple(List<String> lines) {
		for (String string : lines) {
			// ̑Iꍇ
			if (string.startsWith("<choices>")) {
				return true;
			}
			// Ȍꍇ
			else if (string.startsWith("<lat>")) {
				return false;
			}
		}
		return false;
	}

	private GeoData getGeocodedDataFromResponse(List<String> getLines) {
		String latitude = "";
		String longitude = "";
		String locationName = "";
		// n擾
		for (String string : getLines) {
			// PƂ̑Ȉꍇ
			if (string.startsWith("<lat>")) {
				latitude = getLatitude(string);
			} else if (string.startsWith("<lng>")) {
				longitude = getLongitude(string);
			} else if (string.startsWith("<address>")) {
				locationName = getAddress(string);
			}
		}
		// 
		if (latitude.equals("") || longitude.equals("")) {
			latitude = NOTFOUND;
			longitude = NOTFOUND;
		}
		GeoData geoData = new GeoData(locationName, latitude, longitude);
		return geoData;
	}

	/**
	 * ܓx̍sܓxԂ
	 * 
	 * @param lat
	 * @return
	 */
	private String getLatitude(String lat) {
		String newString = lat.replace("<lat>", "");
		newString = newString.replace("</lat>", "");
		return newString;
	}

	/**
	 * yx̍sܓxԂ
	 * 
	 * @param lat
	 * @return
	 */
	private String getLongitude(String lng) {
		String newString = lng.replace("<lng>", "");
		newString = newString.replace("</lng>", "");
		return newString;
	}

	/**
	 * nԂ
	 * 
	 * @param input
	 * @return
	 */
	private String getAddress(String input) {
		String newString = input.replace("<address>", "");
		newString = newString.replace("</address>", "");
		return newString;
	}

	/**
	 * I̒̑Io
	 * 
	 * @param choice
	 * @return
	 */
	private String getOneChoice(String choice) {
		String newString = choice.replace("<choice>", "");
		newString = newString.replace("</choice>", "");
		return newString;
	}

	/**
	 * X|Xn擾
	 * 
	 * @param getLines
	 * @return
	 */
	private List<String> getLocationNameFromResponse(List<String> getLines) {
		List<String> locationNames = new ArrayList<String>();
		for (String string : getLines) {
			if (string.startsWith("<address>")) {
				locationNames.add(getAddress(string));
				SystemLogger.writer.writeDebug("got location:"
						+ getAddress(string));// fobOo
				return locationNames;
			}
		}
		SystemLogger.writer.writeDebug("no location found");// fobOo
		return null;
	}

	/**
	 * X|Xnꗗ擾
	 * 
	 * @param getLines
	 * @return
	 */
	private List<String> getLocationNamesFromResponse(List<String> getLines) {
		List<String> locationNames = new ArrayList<String>();
		for (String string : getLines) {
			// ̑Iꍇ
			if (string.startsWith("<choice>")) {
				locationNames.add(getOneChoice(string));
				SystemLogger.writer.writeDebug("got location:"
						+ getOneChoice(string));// fobOo
			}
		}
		return locationNames;
	}

}
