package geocode;

import java.util.List;

import log.AccessLogger;
import log.SystemLogger;
import setting.GeocodeSettings;

/**
 * nܓxox擾NX
 * 
 * @author Toshiyuki Sato
 * 
 */
public class Geocoder {

	// ϐS
	GeocodeSettings settings;

	/**
	 * RXgN^
	 * 
	 * @param settings
	 */
	public Geocoder(GeocodeSettings settings) {
		this.settings = settings;
	}

	/**
	 * ͂ꂽZNCAgɕԂlpӂ
	 * 
	 * @param request
	 * @return
	 */
	public String geocode(String request) {
		// NGXgs̏ꍇ͏I
		if (!checkRequest(request)) {// s̏ꍇ
			AccessLogger.writer.writeWarning(AccessLogger.WARNING_BAD_REQUEST);
			return null;
		}

		String result = getGeoData(request);// n擾
		// Oɏo͂
		if (result != null) {// n񂪌ꍇ
			AccessLogger.writer.writeInfo(AccessLogger.REQUEST_FOUND + " :"
					+ request);
		} else {// n񂪌Ȃꍇ
			AccessLogger.writer.writeInfo(AccessLogger.REQUEST_NOTFOUND + " :"
					+ request);
		}

		// nԂ
		return result;
	}

	/**
	 * o͗pn񕶎擾
	 * 
	 * @param request
	 * @return
	 */
	private String getGeoData(String request) {
		SystemLogger.writer.writeDebug("Try to get geodata");// fobOvg
		GeoDataManager manager = new GeoDataManager(settings);
		DBManager dbManager = new DBManager(settings);
		
		// n񃊃Xg擾
		manager.updateDatabase(request, dbManager);// DBXV
		// int requestTimes = manager.getRequestTimes(request);// 񐔂擾
		List<GeoData> geoDatas = manager.getGeoDatas(request, dbManager);
		dbManager.closeConnection();// ڑ؂
		
		// n񃊃Xgo͗p擾
		String result = organizeGeocodedDatas(geoDatas);
		SystemLogger.writer.writeDebug("Get geodata succeed:" + result);// fobOvg
		return result;
	}

	/**
	 * n񃊃Xgo͗p쐬
	 * 
	 * @param geoDatas
	 * @return
	 */
	private String organizeGeocodedDatas(List<GeoData> geoDatas) {
		if (geoDatas == null || geoDatas.isEmpty()) {// Xg̏ꍇ
			// TODO:n擾ł܂łOfiG[ł͂Ȃj
			return null;
		}

		// Xgɒn񂪂ꍇAo͗p쐬
		String result = null;
		for (GeoData data : geoDatas) {
			if (data.isNotEmpty()) {
				if (result == null){//ڂ̗vf̏ꍇ
					result = "";
				}else {// 2ڈȍ~̗vf̏ꍇ
					// Z~R}
					result += ";";
				}
				// uܓx,oxv̕쐬
				result += data.getLatitude() + "," + data.getLongitude();
			}
		}
		return result;
	}

	/**
	 * NGXg̐`FbN
	 * 
	 * @param request
	 *            NGXg
	 * @return NGXgȏꍇtrueAsȏꍇfalseԂ
	 */
	private boolean checkRequest(String request) {
		return request != null && !(request.equals(""));
	}
}
