package geocode;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;

import log.AccessLogger;
import log.SystemLogger;
import setting.GeocodeSettings;

/**
 * 1̃Xbh\NX
 * 
 * @author Toshiyuki Sato
 * 
 */
public class RequestProcessor extends Thread {

	private Socket socket = null;

	Geocoder geocoder;

	GeocodeSettings settings;

	/**
	 * RXgN^
	 * 
	 * @param socket
	 * @param settings
	 */
	public RequestProcessor(Socket socket, GeocodeSettings settings) {
		this.socket = socket;
		geocoder = new Geocoder(settings);
		this.settings = settings;
	}

	/**
	 * NGXgɑΉ郌X|XԂ
	 */
	public void run() {
		try {
			// O
			PrintWriter output = new PrintWriter(socket.getOutputStream(), true);// o͗pC^tF[X
			BufferedReader input = new BufferedReader(new InputStreamReader(
					socket.getInputStream(), settings.getRequestEncode()));// ͗pC^tF[X
			// BufferedReader input = new BufferedReader(new
			// InputStreamReader(socket.getInputStream(),
			// settings.getRequestEncode()));// ͗pC^tF[X

			// X|XԂ
			String inputLine = input.readLine();// f[^擾
			AccessLogger.writer.writeInfo(AccessLogger.REQUEST_RECEIVE + " :"
					+ inputLine);// Oɏo͂
			SystemLogger.writer.writeDebug("Request recieved:" + inputLine
					+ " from" + socket.getInetAddress());// fobOvg
			String result = geocoder.geocode(inputLine);// X|Xl擾
			SystemLogger.writer.writeDebug("Returning result:" + result);// fobOvg
			output.println(result);// o͂
			SystemLogger.writer
					.writeDebug("Succeed returning result:" + result);// fobOvg

			// ㏈
			input.close(); // Xg[
			output.close();
			socket.close(); // \Pbg

		} catch (IOException e) {
			SystemLogger.writer.writeError(SystemLogger.ERROR_SOCKET, e);
		}
	}
}