package main;

import geocode.RequestProcessor;

import java.io.File;
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

import log.AccessLogger;
import log.LogWriter;
import log.SystemLogger;
import setting.GeocodeSettings;

/**
 * Geocoding Module
 * 
 * @author g-mod Project
 * @version 1.0
 */
public class GeocodingModule {

	GeocodeSettings settings; // Geocoding Modulȅݒ

	ServerSocket serverSocket; // Geocoding ModulepT[o\Pbg

	public static void main(String args[]) {
		GeocodingModule geocodingModule = new GeocodingModule();
		geocodingModule.run();
	}

	/**
	 * Geocoding ModuleN
	 */
	public void run() {

		System.out.println("Geocoding Module Started");// Jnm点
		initSettings();// W[ݒ
		startLogger(); // O̐ݒiȑOɃOɓfoKvoꍇ́AftHg̃tH_ɏo͂j
		startService();// T[rXJn
	}

	/**
	 * W[̐ݒ
	 */
	private void initSettings() {
		settings = new GeocodeSettings();
		// ݒt@Cǂݍ
		if (settings.readConfigFile()) { // ǂݍ݂ɐꍇ
			// ݒt@CĂ邩`FbN
			if (settings.checkConfigFile() == false) { // Ăꍇ
				SystemLogger.writer.writeError(SystemLogger.ERROR_CFG_BROKEN, null);
				terminate();
			}
		} else { // ǂݍ݂Ɏsꍇ
			SystemLogger.writer.writeError(SystemLogger.ERROR_CFG_CANT_READ, null);
			terminate();
		}
	}

	/**
	 * T[rXJn
	 */
	private void startService() {
		try {
			SystemLogger.writer.writeInfo(SystemLogger.MODULE_START_SERVICE);
			serverSocket = new ServerSocket(settings.getModulePort()); // T[o\PbgJ

			// NCAgNGXg
			while (true) {
				// NCAgNGXg҂
				Socket socket = serverSocket.accept();
				// NCAgNGXg󗝂Xbh쐬
				try {
					RequestProcessor thread = new RequestProcessor(socket,
							settings);
					thread.start();
				} catch (Exception e) {
					SystemLogger.writer.writeError(SystemLogger.ERROR_SOCKET, e);
					terminate();
				}
			}
		} catch (IOException e) {
			SystemLogger.writer.writeError(SystemLogger.ERROR_SOCKET, e);
			terminate();
		}
	}

	/**
	 * Oo͋@\N
	 */
	private void startLogger() {
		// Ȍo̗͂L߂
		// VXeȌo̗͂L߂
		if (settings.getLogLevel().equals("DEBUG")) {
			LogWriter.setLogLevel(LogWriter.DEBUG);
		} else if (settings.getLogLevel().equals("INFO")) {
			LogWriter.setLogLevel(LogWriter.INFO);
		} else if (settings.getLogLevel().equals("WARNING")){
			LogWriter.setLogLevel(LogWriter.WARNING);
		} else if (settings.getLogLevel().equals("ERROR")){
			LogWriter.setLogLevel(LogWriter.ERROR);
		}

		// Ȍo͐߂
		// VXeȌo͐߂
		if ((new File(settings.getSystemLogPath())).isDirectory()) {
			SystemLogger.writer.setPath(settings.getSystemLogPath());
		}
		// ANZXȌo͐߂
		if ((new File(settings.getAccessLogPath())).isDirectory()) {
			AccessLogger.writer.setPath(settings.getAccessLogPath());
		}

		// GR[hݒ肷
		LogWriter.setEncode(settings.getLogEncode());
	}

	/**
	 * Geocoding ModuleI
	 */
	private void terminate() {
		System.out.println("Geocoding Module Terminated");// IR\[ɋL
		System.exit(1);
	}
}