package test;

import geocode.DBManager;
import geocode.GeoData;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.junit.Before;
import junit.framework.TestCase;
import setting.GeocodeSettings;

/**
 * f[^x[X}l[W̃eXgvO
 * 
 * @author Hideyuki Hirasawa
 * @version 0.1
 */
public class TestDBManager extends TestCase {

	GeocodeSettings settings;

	DBManager testManager;

	final String DB_URL = "jdbc:mysql:///GeocodingModuleDB?useUnicode=true&characterEncoding=UTF8";

	final String KEY_SING = "񂩂񂹂";

	final String KEY_MULTI = "{";

	final String KEY_NONE = "";

	final String DATA_SING = "s{ss拞swV";

	final String DATA_MULTIA = "{wij";

	final String DATA_MULTIB = "{wij";

	final String DATA_MULTIC = "{wiLj";

	/**
	 * T[`L[f[^x[Xɑ݂邩ǂm߂
	 */
	public final void testKeyExist() {

		try {
			// ꎞϐ
			boolean result;
			String sql;
			ResultSet rs;
			int count;

			// f[^x[Xɐڑ
			Class.forName("org.gjt.mm.mysql.Driver");
			Connection c = DriverManager.getConnection(DB_URL, "root", "");
			Statement stat = c.createStatement();

			// L[f[^x[Xɑ݂
			addRequestData(KEY_SING, (new Date().getTime()));
			result = testManager.keyExist(KEY_SING);
			sql = "SELECT * FROM geocodingRequest WHERE searchQuery = '"
					+ KEY_SING + "'";
			rs = stat.executeQuery(sql);
			count = sizeResultSet(rs);
			if (result == false || count != 1)
				fail();

			// L[f[^x[X݂Ȃ
			deleteTempData();
			result = testManager.keyExist(KEY_SING);
			rs = stat.executeQuery(sql);
			count = sizeResultSet(rs);
			if (result == true || count != 0)
				fail();

		} catch (SQLException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}

	}

	/**
	 * L[̌񐔂XV
	 */
	public final void testUpdateRequestTimes() {
		int times = testManager.getRequestTimes(KEY_SING);
		testManager.updateRequestTimes(KEY_SING);
		addRequestData(KEY_SING, 0);
		assertEquals(times + 1, testManager.getRequestTimes(KEY_SING));
	}

	/**
	 * T[`L[̗LmF
	 */
	public final void testKeyExpired() {

		// ؂Ăꍇ
		addRequestData(KEY_SING, 0);
		assertTrue(testManager.keyExpired(KEY_SING));

		// ؂ĂȂꍇ
		deleteTempData();
		addRequestData(KEY_SING, (new Date().getTime()));
		assertFalse(testManager.keyExpired(KEY_SING));

	}

	/**
	 * T[`L[ɊYnXgf[^x[Xɒǉł邩ǂm߂
	 */
	public final void testAddKey() {

		try {

			// ꎞϐ
			List<String> keyList = new ArrayList<String>();
			boolean result;
			String sql;
			ResultSet rs;
			int count;

			// f[^x[Xɐڑ
			Class.forName("org.gjt.mm.mysql.Driver");
			Connection c = DriverManager.getConnection(DB_URL, "root", "");
			Statement stat = c.createStatement();

			// nXg̒1̏ꍇ
			keyList.add(DATA_SING);
			testManager.addKey(KEY_SING, keyList);
			result = testManager.keyExist(KEY_SING);
			sql = "SELECT * FROM geocodingLink WHERE searchQuery = '"
					+ KEY_SING + "'";
			rs = stat.executeQuery(sql);
			count = sizeResultSet(rs);
			if (result == false || count != 1)
				fail();

			// nXg̒N̏ꍇ
			keyList = new ArrayList<String>();
			keyList.add(DATA_MULTIA);
			keyList.add(DATA_MULTIB);
			keyList.add(DATA_MULTIC);
			testManager.addKey(KEY_MULTI, keyList);
			result = testManager.keyExist(KEY_MULTI);
			sql = "SELECT * FROM geocodingLink WHERE searchQuery = '"
					+ KEY_MULTI + "'";
			rs = stat.executeQuery(sql);
			count = sizeResultSet(rs);
			if (result == false || count != 3)
				fail();

			// nXgȂꍇ
			testManager.addKey(KEY_NONE, null);
			result = testManager.keyExist(KEY_NONE);
			sql = "SELECT * FROM geocodingLink WHERE searchQuery = '"
					+ KEY_NONE + "'";
			rs = stat.executeQuery(sql);
			count = sizeResultSet(rs);
			if (result == false || count != 0)
				fail();

		} catch (SQLException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}

	}

	/**
	 * T[`L[ɊYnXgXVł邩ǂm߂
	 */
	public final void testUpdateKey() {

		try {

			// ꎞϐ
			List<String> keyList = new ArrayList<String>();
			boolean result;
			String sql;
			ResultSet rs;
			int count;

			// O
			Class.forName("org.gjt.mm.mysql.Driver");
			Connection c = DriverManager.getConnection(DB_URL, "root", "");
			Statement stat = c.createStatement();
			addRequestData(KEY_SING, (new Date(0).getTime()));
			addRequestData(KEY_MULTI, (new Date(0).getTime()));
			addRequestData(KEY_NONE, (new Date(0).getTime()));

			// nXg̒1̏ꍇ
			keyList.add(DATA_SING);
			testManager.updateKey(KEY_SING, keyList);
			result = testManager.keyExpired(KEY_SING);
			sql = "SELECT * FROM geocodingLink WHERE searchQuery = '"
					+ KEY_SING + "'";
			rs = stat.executeQuery(sql);
			count = sizeResultSet(rs);
			if (result == true || count != 1)
				fail();

			// nXg̒N̏ꍇ
			keyList.clear();
			keyList.add(DATA_MULTIA);
			keyList.add(DATA_MULTIB);
			keyList.add(DATA_MULTIC);
			testManager.updateKey(KEY_MULTI, keyList);
			result = testManager.keyExpired(KEY_MULTI);
			sql = "SELECT * FROM geocodingLink WHERE searchQuery = '"
					+ KEY_MULTI + "'";
			rs = stat.executeQuery(sql);
			count = sizeResultSet(rs);
			if (result == true || count != 3)
				fail();

			// nXgȂꍇ
			testManager.updateKey(KEY_NONE, null);
			result = testManager.keyExpired(KEY_NONE);
			sql = "SELECT * FROM geocodingLink WHERE searchQuery = '"
					+ KEY_NONE + "'";
			rs = stat.executeQuery(sql);
			count = sizeResultSet(rs);
			if (result == true || count != 0)
				fail();

		} catch (SQLException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}

	}

	/**
	 * nɊYn񂪃f[^x[Xɑ݂邩ǂm߂
	 */
	public final void testDataExist() {

		try {

			// ꎞϐ
			boolean result;
			String sql;
			ResultSet rs;
			int count;

			// f[^x[Xɐڑ
			Class.forName("org.gjt.mm.mysql.Driver");
			Connection c = DriverManager.getConnection(DB_URL, "root", "");
			Statement stat = c.createStatement();

			// n񂪃f[^x[Xɑ݂
			addGeocodeData(DATA_SING, (new Date().getTime()));
			result = testManager.dataExist(DATA_SING);
			sql = "SELECT * FROM geocodingData WHERE locationName = '"
					+ DATA_SING + "'";
			rs = stat.executeQuery(sql);
			count = sizeResultSet(rs);
			if (result == false || count != 1)
				fail();

			// n񂪃f[^x[X݂Ȃ
			deleteTempData();
			result = testManager.dataExist(DATA_SING);
			rs = stat.executeQuery(sql);
			count = sizeResultSet(rs);
			if (result == true || count != 0)
				fail();

		} catch (SQLException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}

	}

	/**
	 * n̗Lm߂
	 */
	public final void testDataExpired() {

		// ؂Ăꍇ
		addGeocodeData(DATA_SING, 0);
		assertTrue(testManager.dataExpired(DATA_SING));

		// ؂ĂȂꍇ
		deleteTempData();
		addGeocodeData(DATA_SING, (new Date().getTime()));
		assertFalse(testManager.dataExpired(DATA_SING));

	}

	/**
	 * nf[^x[Xɒǉł邩ǂm߂
	 */
	public final void testAddData() {
		GeoData data;
		data = new GeoData(DATA_SING, "100", "100");
		testManager.addData(data);
		assertTrue(testManager.dataExist(DATA_SING));
	}

	/**
	 * nXVł邩ǂm߂
	 */
	public final void testUpdateData() {
		GeoData data;
		addGeocodeData(DATA_SING, 0);
		data = new GeoData(DATA_SING, "100", "100");
		testManager.updateData(data);
		assertFalse(testManager.dataExpired(DATA_SING));
	}

	/**
	 * T[`L[ɊYnXg擾ł邩ǂm߂
	 */
	public final void testGetLocationNameList() {

		// ꎞϐ
		List<String> keyList = new ArrayList<String>();
		List<String> list = new ArrayList<String>();

		// 擾łnXg̒1̏ꍇ
		keyList.add(DATA_SING);
		testManager.addKey(KEY_SING, keyList);
		list = testManager.getLocationNameList(KEY_SING);
		assertEquals(1, list.size());

		// 擾łnXg̒N̏ꍇ
		keyList = new ArrayList<String>();
		keyList.add(DATA_MULTIA);
		keyList.add(DATA_MULTIB);
		keyList.add(DATA_MULTIC);
		testManager.addKey(KEY_MULTI, keyList);
		list = testManager.getLocationNameList(KEY_MULTI);
		assertEquals(settings.getReturnMax(), list.size());

		// 擾łnXgȂꍇ
		testManager.addKey(KEY_NONE, null);
		list = testManager.getLocationNameList(KEY_NONE);
		assertEquals(0, list.size());

	}

	/**
	 * T[`L[ɊYn擾ł邩ǂm߂
	 */
	public final void testGetGeodata() {

		// ꎞϐ
		List<String> keyList = new ArrayList<String>();
		GeoData data;
		List<GeoData> list = new ArrayList<GeoData>();

		// 擾łn1̏ꍇ
		keyList.add(DATA_SING);
		testManager.addKey(KEY_SING, keyList);
		data = new GeoData(DATA_SING, "100", "100");
		testManager.addData(data);
		list = testManager.getGeodata(KEY_SING);
		assertEquals(1, list.size());

		// 擾łnN̏ꍇ
		keyList.clear();
		keyList.add(DATA_MULTIA);
		keyList.add(DATA_MULTIB);
		keyList.add(DATA_MULTIC);
		testManager.addKey(KEY_MULTI, keyList);
		data = new GeoData(DATA_MULTIA, "100", "100");
		testManager.addData(data);
		data = new GeoData(DATA_MULTIB, "100", "100");
		testManager.addData(data);
		data = new GeoData(DATA_MULTIC, "100", "100");
		testManager.addData(data);
		list = testManager.getGeodata(KEY_MULTI);
		assertEquals(settings.getReturnMax(), list.size());

		// 擾łn񂪂Ȃꍇ
		testManager.addKey(KEY_NONE, null);
		list = testManager.getGeodata(KEY_NONE);
		assertEquals(0, list.size());

	}

	/***************************************************************************
	 * eXgpӃ\bhS
	 **************************************************************************/

	@Before
	public void setUp() throws Exception {
		settings = new GeocodeSettings();
		settings.readConfigFile();
		testManager = new DBManager(settings);
		deleteTempData();
	}

	/**
	 * f[^폜
	 */
	void deleteTempData() {
		try {

			// f[^x[Xɐڑ
			Class.forName("org.gjt.mm.mysql.Driver");
			Connection c = DriverManager.getConnection(DB_URL, "root", "");
			Statement stat = c.createStatement();

			// geocodingRequesteXgf[^폜
			String sql = "DELETE FROM geocodingRequest WHERE searchQuery = '"
					+ KEY_SING + "'";
			stat.executeUpdate(sql);
			sql = "DELETE FROM geocodingRequest WHERE searchQuery = '"
					+ KEY_MULTI + "'";
			stat.executeUpdate(sql);
			sql = "DELETE FROM geocodingRequest WHERE searchQuery = '"
					+ KEY_NONE + "'";
			stat.executeUpdate(sql);

			// geocodingLinkeXgf[^폜
			sql = "DELETE FROM geocodingLink WHERE searchQuery = '" + KEY_SING
					+ "'";
			stat.executeUpdate(sql);
			sql = "DELETE FROM geocodingLink WHERE searchQuery = '" + KEY_MULTI
					+ "'";
			stat.executeUpdate(sql);
			sql = "DELETE FROM geocodingLink WHERE searchQuery = '" + KEY_NONE
					+ "'";
			stat.executeUpdate(sql);

			// geocodingDataeXgf[^폜
			sql = "DELETE FROM geocodingData WHERE locationName = '"
					+ DATA_SING + "'";
			stat.executeUpdate(sql);
			sql = "DELETE FROM geocodingData WHERE locationName = '"
					+ DATA_MULTIA + "'";
			stat.executeUpdate(sql);
			sql = "DELETE FROM geocodingData WHERE locationName = '"
					+ DATA_MULTIB + "'";
			stat.executeUpdate(sql);
			sql = "DELETE FROM geocodingData WHERE locationName = '"
					+ DATA_MULTIC + "'";
			stat.executeUpdate(sql);

		} catch (SQLException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}

	/**
	 * L[ǉ
	 */
	void addRequestData(String searchQuery, long time) {
		try {
			Class.forName("org.gjt.mm.mysql.Driver");
			Connection c = DriverManager.getConnection(DB_URL, "root", "");
			Statement stat = c.createStatement();
			java.sql.Date date = new java.sql.Date(time);
			String sql = "insert into geocodingRequest values ('" + searchQuery
					+ "',1,'" + date + "')";
			stat.executeUpdate(sql);
		} catch (SQLException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}

	/**
	 * nǉ
	 */
	void addGeocodeData(String locationName, long time) {
		try {
			Class.forName("org.gjt.mm.mysql.Driver");
			Connection c = DriverManager.getConnection(DB_URL, "root", "");
			Statement stat = c.createStatement();
			java.sql.Date date = new java.sql.Date(time);
			String sql = "insert into geocodingData values ('" + locationName
					+ "',100,200,'" + date + "','" + date + "')";
			stat.executeUpdate(sql);
		} catch (SQLException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}

	/**
	 * YԂ
	 */
	int sizeResultSet(ResultSet rs) {
		int count = 0;
		try {
			while (rs.next())
				count++;
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return count;
	}
}
