package test;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import setting.GeocodeSettings;

public class TestGeocodeSettings {
	
	GeocodeSettings settings = new GeocodeSettings();

	@Test
	/**
	 * RtBOt@Cǂݍ߂ǂ𔻒肷@\̃eXg
	 */
	public void testReadConfigFile() {
		// RtBOt@C݂ꍇATrueԂ
		createConfigFileNormal();
		assertTrue(settings.readConfigFile());
		// RtBOt@C݂ȂꍇAFalseԂ
		settings = new GeocodeSettings();
		deleteFile();
		assertFalse(settings.readConfigFile());
		// RtBOt@C̍ڂĂꍇAFalseԂ
		settings = new GeocodeSettings();
		createConfigFileLacking();
		assertFalse(settings.readConfigFile());
	}

	@Test
	/**
	 * Ғʂ̒lǂݍނƂłǂ𔻒肷@\̃eXg
	 */
	public void testCheckConfigFile() {
		// RtBȌꍇ̏ꍇATrueԂ
		createConfigFileNormal();
		assertTrue(settings.readConfigFile());
		assertTrue(settings.checkConfigFile());
		// RtBOt@CłȂꍇAFalseԂ
		settings = new GeocodeSettings();
		createConfigFileAbnormal();
		assertTrue(settings.readConfigFile());
		assertFalse(settings.checkConfigFile());
	}

	/**
	 * ŏɃobNAbvƂĂ
	 * 
	 * @throws Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		java.io.File prop = new java.io.File("geoConfig.prop");
		java.io.File temp = new java.io.File("temp.prop");
		temp.delete();
		prop.renameTo(temp);
	}

	/**
	 * ŌɃobNAbv𕜌
	 * 
	 * @throws Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
		java.io.File prop = new java.io.File("temp.prop");
		java.io.File temp = new java.io.File("geoConfig.prop");
		temp.delete();
		prop.renameTo(temp);
	}

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	/**
	 * SĂ̍ڂ܂RtBOt@Co͂
	 */
	private void createConfigFileNormal() {
		try {
			File prop = new File("geoConfig.prop");
			prop.delete();
			BufferedWriter logBuffer = new BufferedWriter(new FileWriter(prop,
					true));
			logBuffer
					.write("modulePort=8080\n"
							+ "requestEncode=UTF-8\n"
							+ "requestWaitTime=5000\n"
							+ "returnMax=2\n"
							+ "cacheExpiration=15\n"
							+ "searchKeyExpiration=15\n"
							+ "apiURL=http://www.geocoding.jp/api/?q=\n"
							+ "apiEncode=UTF-8\n"
							+ "logEncode=UTF-8\n"
							+ "logLevel=DEBUG\n"
							+ "systemLogPath=./systemLog/\n"
							+ "accessLogPath=./accessLog/\n"
							+ "DBURL=jdbc:mysql:///geocodingmoduledb?useUnicode=true&characterEncoding=UTF8\n"
							+ "DBUserName=root\n" + "DBPass=\n");
			logBuffer.newLine();
			logBuffer.close();
		} catch (Exception e) {

		}
	}

	/**
	 * t@C
	 */
	private void deleteFile() {
		File prop = new File("geoConfig.prop");
		prop.delete();
	}

	/**
	 * ڂɑΉ̂ԈĂRtBOt@Co͂
	 */
	private void createConfigFileAbnormal() {
		try {
			File prop = new File("geoConfig.prop");
			prop.delete();
			BufferedWriter logBuffer = new BufferedWriter(new FileWriter(prop,
					true));
			logBuffer
					.write("modulePort=808000\n"
							+ "requestEncode=UTF-8\n"
							+ "requestWaitTime=5000\n"
							+ "returnMax=2\n"
							+ "cacheExpiration=15\n"
							+ "searchKeyExpiration=15\n"
							+ "apiURL=http://www.geocoding.jp/api/?q=\n"
							+ "apiEncode=UTF-8\n"
							+ "logEncode=UTF-8\n"
							+ "logLevel=DEBUG\n"
							+ "systemLogPath=./systemLog/\n"
							+ "accessLogPath=./accessLog/\n"
							+ "DBURL=jdbc:mysql:///geocodingmoduledb?useUnicode=true&characterEncoding=UTF8\n"
							+ "DBUserName=root\n" + "DBPass=\n");
			logBuffer.newLine();
			logBuffer.close();
		} catch (Exception e) {

		}
	}

	/**
	 * ڂĂRtBOt@C쐬 łreturnMax𔲂
	 */
	private void createConfigFileLacking() {
		try {
			File prop = new File("geoConfig.prop");
			prop.delete();
			BufferedWriter logBuffer = new BufferedWriter(new FileWriter(prop,
					true));
			logBuffer
					.write("modulePort=8080\n"
							+ "requestEncode=UTF-8\n"
							+ "requestWaitTime=5000\n"
							+ "cacheExpiration=15\n"
							+ "searchKeyExpiration=15\n"
							+ "apiURL=http://www.geocoding.jp/api/?q=\n"
							+ "apiEncode=UTF-8\n"
							+ "logEncode=UTF-8\n"
							+ "logLevel=DEBUG\n"
							+ "systemLogPath=./systemLog/\n"
							+ "accessLogPath=./accessLog/\n"
							+ "DBURL=jdbc:mysql:///geocodingmoduledb?useUnicode=true&characterEncoding=UTF8\n"
							+ "DBUserName=root\n" + "DBPass=\n");
			logBuffer.newLine();
			logBuffer.close();
		} catch (Exception e) {

		}
	}
}