package test;

import geocode.Geocoder;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Date;

import junit.framework.TestCase;

import org.junit.After;
import org.junit.Before;
import org.junit.BeforeClass;

import setting.GeocodeSettings;

public class TestGeocoder extends TestCase {

	static Geocoder geocoder;

	static Statement stat;

	/**
	 * NGXg󂯁AɑΉ镶񂪍쐬ł̃eXg
	 */
	public void testGeocode() {
		// L[֘ÃeXg
		{
			// L[ɑΉ錟ĂȂꍇAL[ǉĂ
			geocoder.geocode("l");
			String result = getValueFromDB("geocodingrequest", "searchquery",
					"searchquery", "l");
			assertEquals("l", result);
			// L[ɑΉ錟ĂAXVԂ߂ĂꍇAL[XV
			geocoder.geocode("]");
			Date date = getDateFromDB("GeocodingRequest", "lastUpdatedRequest",
					"searchquery", "]");
			assertTrue(new Date().after(date));
			// L[ɑΉ錟ĂAXVԂ߂ĂȂꍇAL[񐔈ȊOXVȂ
			date = getDateFromDB("GeocodingRequest", "lastUpdatedRequest",
					"searchquery", "");
			geocoder.geocode("");
			Date newDate = getDateFromDB("GeocodingRequest",
					"lastUpdatedRequest", "searchquery", "");
			assertEquals(date, newDate);
		}

		setTestDatas();// xZbg

		// n֘ÃeXg
		{
			// L[ɑΉn񂪑݂ȂꍇAn񂪒ǉĂ
			geocoder.geocode("l");
			String result = getValueFromDB("GeocodingData", "locationname",
					"locationname", "l");
			assertEquals("l", result);
			// L[ɑΉn񂪑݂AXVԂ߂ĂꍇAn񂪍XVĂ
			geocoder.geocode("]");
			Date date = getDateFromDB("GeocodingData", "lastUpdated",
					"locationname", "]");
			assertTrue(new Date().after(date));
			// L[ɑΉn񂪑݂AXVԂ߂ĂȂꍇAύXȂ
			date = getDateFromDB("GeocodingData", "lastUpdated",
					"locationname", "");
			geocoder.geocode("");
			Date newDate = getDateFromDB("GeocodingData", "lastUpdated",
					"locationname", "");
			assertEquals(date, newDate);
		}

		setTestDatas();// xZbg

		// ʊ֘A
		{
			// L[ɑΉn񂪒P̏ꍇAx,y̌`ŕԂ
			assertEquals("100,200", geocoder.geocode(""));
			// L[ɑΉn񂪕̏ꍇAx,y:x,y̌`ŕԂ
			assertEquals("200,300;300,400", geocoder.geocode("Oc"));
			// L[ɑΉn񂪖ꍇAnullԂ
			assertEquals(null, geocoder.geocode(""));
		}
	}

	/***************************************************************************
	 * 
	 * eXgpӗp\bhS
	 * 
	 **************************************************************************/

	@BeforeClass
	public void createStatement() throws Exception {
		// CX^X𐶐
		GeocodeSettings settings = new GeocodeSettings();
		settings.readConfigFile();
		// DB̐ݒiłj
		geocoder = new Geocoder(settings);
		Class.forName("org.gjt.mm.mysql.Driver");
		Connection c = DriverManager.getConnection(settings.getDBURL(),
				settings.getDBUserName(), settings.getDBPass());
		stat = c.createStatement();
	}

	@Before
	public void setUp() throws Exception {
		createStatement();
		setTestDatas();
	}

	@After
	public void tearDown() throws Exception {
		stat.close();
	}

	/**
	 * DB
	 */
	private void setTestDatas() {
		try {
			String searchQuery;
			String locationName;

			// DB
			String sql = "delete from geocodingRequest";
			stat.executeUpdate(sql);
			sql = "delete from geocodingLink";
			stat.executeUpdate(sql);
			sql = "delete from geocodingData";
			stat.executeUpdate(sql);

			// f[^pӂ
			// L[֘A
			{
				// ؂ĂȂꍇ
				{
					// PƂ̏ꍇ
					searchQuery = "";
					locationName = "";
					java.sql.Date date = new java.sql.Date(new Date().getTime()
							- 1000L * 24L * 60L * 60L);
					sql = "insert into geocodingRequest values ('"
							+ searchQuery + "',1,'" + date + "')";
					stat.executeUpdate(sql);
					sql = "insert into geocodingLink values ('" + searchQuery
							+ "','" + locationName + "',1)";
					stat.executeUpdate(sql);
					// ݂ꍇ
					searchQuery = "Oc";
					locationName = "Ocwij";
					date = new java.sql.Date(new Date().getTime());
					sql = "insert into geocodingRequest values ('"
							+ searchQuery + "',2,'" + date + "')";
					stat.executeUpdate(sql);
					sql = "insert into geocodingLink values ('" + searchQuery
							+ "','" + locationName + "',1)";
					stat.executeUpdate(sql);
					locationName = "OcwiɁj";
					sql = "insert into geocodingLink values ('" + searchQuery
							+ "','" + locationName + "',2)";
					stat.executeUpdate(sql);
				}
				// ؂Ăꍇ
				searchQuery = "]";
				locationName = "]";
				Date date = new java.sql.Date(0);
				sql = "insert into geocodingRequest values ('" + searchQuery
						+ "',1,'" + date + "')";
				stat.executeUpdate(sql);
				sql = "insert into geocodingLink values ('" + searchQuery
						+ "','" + locationName + "',1)";
				stat.executeUpdate(sql);

			}
			// n֘A
			{
				// ؂ĂȂꍇ
				{
					java.sql.Date date = new java.sql.Date(new Date().getTime());
					// PƂ̏ꍇ
					locationName = "";
					sql = "insert into geocodingData values ('" + locationName
							+ "',100,200,'" + date + "','" + date + "')";
					stat.executeUpdate(sql);
					// ̏ꍇ
					locationName = "Ocwij";
					sql = "insert into geocodingData values ('" + locationName
							+ "',200,300,'" + date + "','" + date + "')";
					stat.executeUpdate(sql);
					locationName = "OcwiɁj";
					sql = "insert into geocodingData values ('" + locationName
							+ "',300,400,'" + date + "','" + date + "')";
					stat.executeUpdate(sql);
				}
				// ؂Ăꍇ
				Date date = new java.sql.Date(0);
				locationName = "]";
				sql = "insert into geocodingData values ('" + locationName
						+ "',100,200,'" + date + "','" + date + "')";
				stat.executeUpdate(sql);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * DB擾lQbg
	 */
	private String getValueFromDB(String table, String target, String query,
			String request) {
		try {
			// 擾
			String sql = "select " + target + " from " + table + " where "
					+ query + " ='" + request + "'";
			ResultSet rs = stat.executeQuery(sql);

			// 擾łׂ
			while (rs.next()) {
				return rs.getString(target);
			}
			return null;
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	/**
	 * DB擾tQbg
	 */
	private Date getDateFromDB(String table, String target, String query,
			String request) {
		try {
			// 擾
			String sql = "select " + target + " from " + table + " where "
					+ query + " = '" + request + "'";
			ResultSet rs = stat.executeQuery(sql);

			// 擾łׂ
			while (rs.next()) {
				return rs.getDate(target);
			}
			return null;
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}
}
